###############################################################################
# PostScript printing here
###############################################################################

set A4WIDTH 21.0
set A4HEIGHT 29.7
set USWIDTH [expr 8.5 * 2.54]
set USHEIGHT [expr 11 * 2.54]

# defaults (for my address book!)
# all dimensions in Centimeters
set PAPERSIZE	"A4"
set PAGEWIDTH	9.0
set PAGEHEIGHT	12.0
set TOPM		0.7
set BOTM		0.2
set LEFTM		1.0
set RIGHTM		0.2
set FONTSIZE	9
set ADDRWIDTH	4.0
set SEPARATION	0.3
set FONTNAME	"Times-Roman"
set HOLEDIAM	0.5
#set HOLES		{{0.5 1.2} {0.5 3.1} {0.5 5.0} {0.5 6.9} {0.5 8.8} {0.5 10.7}}
set HOLES		{}

proc PrintPS {} {
	global SWvar optvars diagram HOLES def_entry_kp pstablist diagram
	global default_listbox_binding

	set diagram 0
	set labwid 15
	set optvars "PAPERSIZE PAGEWIDTH PAGEHEIGHT TOPM \
		BOTM LEFTM RIGHTM FONTSIZE FONTNAME HOLEDIAM \
		ADDRWIDTH SEPARATION"
	eval global $optvars

	GetDefaults;
	set w ".pssetup"
	set pstablist "$w.fn.e $w.page.width $w.page.height \
		$w.margins.rhs.upper.te $w.margins.rhs.upper.be \
		$w.margins.rhs.lower.te $w.margins.rhs.lower.be \
		$w.hd.e $w.hm.xe $w.hm.ye"
	toplevel $w
	### menu stuff
	frame $w.menuf
	pack $w.menuf -side top -expand 1 -fill x
	menubutton $w.menuf.file -text "File"  -menu $w.menuf.file.m
	menu $w.menuf.file.m
	$w.menuf.file.m add command -label "Save" -command "WriteDefaults"
	$w.menuf.file.m add command -label "Quit" -command {set SWvar 0}
	$w.menuf.file.m add command -label "Diagram" -command {MakeDiagram}
	pack $w.menuf.file -side left

	### options
	#frame $w.optf
	#pack $w.optf -side top
	# message
	message $w.notice -text "All Dimensions in CM" -aspect 1500
	pack $w.notice -side top

	frame $w.sep -bg black -height 2
	pack $w.sep -expand 1 -fill x

	# filename
	frame $w.fn
	pack $w.fn -expand 1 -fill x
	label $w.fn.l -text "Filename" -width $labwid
	entry $w.fn.e -width 30 -rel sunk -textvar FILENAME
	bind $w.fn.e <Tab> "Tab \$pstablist"
	bind $w.fn.e <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.fn.e <KeyPress> $def_entry_kp
	pack $w.fn.l $w.fn.e -side left
	
	frame $w.sep4 -bg black -height 2
	pack $w.sep4 -expand 1 -fill x

	# papersize
	frame $w.paper
	pack $w.paper -expand 1 -fill x
	label $w.paper.l -text "Paper Size" -width $labwid
	tk_optionMenu $w.paper.om PAPERSIZE A4 "US(Letter)"
	pack $w.paper.l $w.paper.om -side left

	frame $w.sep0 -bg black -height 2
	pack $w.sep0 -expand 1 -fill x

	# pagesize
	frame $w.page
	pack $w.page -expand 1 -fill x
	label $w.page.l -text "Page Size" -width $labwid

	label $w.page.widthl -text "width" -width 6
	entry $w.page.width -width 6 -rel sunk -textvar PAGEWIDTH
	bind $w.page.width <Tab> "Tab \$pstablist"
	bind $w.page.width <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.page.width <KeyPress> $def_entry_kp
	bind $w.page.width <FocusOut> {RedrawDiagram 1}

	label $w.page.heightl -text "height" -width 6
	entry $w.page.height -width 6 -rel sunk -textvar PAGEHEIGHT
	bind $w.page.height <Tab> "Tab \$pstablist"
	bind $w.page.height <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.page.height <KeyPress> $def_entry_kp
	bind $w.page.height <FocusOut> {RedrawDiagram 1}
	pack $w.page.l $w.page.widthl $w.page.width \
		$w.page.heightl $w.page.height -side left

	frame $w.sep1 -bg black -height 2
	pack $w.sep1 -expand 1 -fill x
	# margins
	frame $w.margins
	pack $w.margins -expand 1 -fill x
	label $w.margins.l -text "Margins" -width $labwid -rel groove
	pack $w.margins.l -side left -fill y
	frame $w.margins.rhs
	pack $w.margins.rhs -side left
	frame $w.margins.rhs.upper
	pack $w.margins.rhs.upper -side top
	frame $w.margins.rhs.lower
	pack $w.margins.rhs.lower -side top
	label $w.margins.rhs.upper.tl -text "top" -width 6
	entry $w.margins.rhs.upper.te -width 6 -rel sunk -textvar TOPM
	bind $w.margins.rhs.upper.te <Tab> "Tab \$pstablist"
	bind $w.margins.rhs.upper.te  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.margins.rhs.upper.te  <KeyPress> $def_entry_kp
	bind $w.margins.rhs.upper.te <FocusOut> {RedrawDiagram 0}
	label $w.margins.rhs.upper.bl -text "bottom" -width 6
	entry $w.margins.rhs.upper.be -width 6 -rel sunk -textvar BOTM
	bind $w.margins.rhs.upper.be <Tab> "Tab \$pstablist"
	bind $w.margins.rhs.upper.be  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.margins.rhs.upper.be  <KeyPress> $def_entry_kp
	bind $w.margins.rhs.upper.be <FocusOut> {RedrawDiagram 0}
	pack $w.margins.rhs.upper.tl $w.margins.rhs.upper.te \
		$w.margins.rhs.upper.bl $w.margins.rhs.upper.be \
		-side left
	label $w.margins.rhs.lower.tl -text "left" -width 6
	entry $w.margins.rhs.lower.te -width 6 -rel sunk -textvar LEFTM
	bind $w.margins.rhs.lower.te <Tab> "Tab \$pstablist"
	bind $w.margins.rhs.lower.te  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.margins.rhs.lower.te  <KeyPress> $def_entry_kp
	bind $w.margins.rhs.lower.te <FocusOut> {RedrawDiagram 0}
	label $w.margins.rhs.lower.bl -text "right" -width 6
	entry $w.margins.rhs.lower.be -width 6 -rel sunk -textvar RIGHTM
	bind $w.margins.rhs.lower.be <Tab> "Tab \$pstablist"
	bind $w.margins.rhs.lower.be  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.margins.rhs.lower.be  <KeyPress> $def_entry_kp
	bind $w.margins.rhs.lower.be <FocusOut> {RedrawDiagram 0}
	pack $w.margins.rhs.lower.tl $w.margins.rhs.lower.te \
		$w.margins.rhs.lower.bl $w.margins.rhs.lower.be \
		-side left

	# separator frame
	frame $w.sep6 -bg black -height 2
	pack $w.sep6 -expand 1 -fill x

	# address width + separation
	frame $w.aw
	pack $w.aw -expand 1 -fill x
	label $w.aw.awl -text "Address Width" -width $labwid
	entry $w.aw.awe -width 6 -rel sunk -textvar ADDRWIDTH
	bind $w.aw.awe <Tab> "Tab \$pstablist"
	bind $w.aw.awe  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.aw.awe  <KeyPress> $def_entry_kp
	bind $w.aw.awe <FocusOut> {RedrawDiagram 0}
	label $w.aw.sepl -text "Separation" -width $labwid
	entry $w.aw.sepe -width 6 -rel sunk -textvar SEPARATION
	bind $w.aw.sepe <Tab> "Tab \$pstablist"
	bind $w.aw.sepe  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.aw.sepe  <KeyPress> $def_entry_kp
	bind $w.aw.sepe <FocusOut> {RedrawDiagram 0}
	pack $w.aw.awl $w.aw.awe $w.aw.sepl $w.aw.sepe -side left

	# separator frame
	frame $w.sep2 -bg black -height 2
	pack $w.sep2 -expand 1 -fill x

	# font size + name
	frame $w.font
	pack $w.font -expand 1 -fill x
	label $w.font.sl -text "Fontsize" -width $labwid -rel flat
	tk_optionMenu $w.font.som FONTSIZE 4 5 6 7 8 9 10 11 12 13 14 15 16
	label $w.font.nl -text "Font" -rel flat
	tk_optionMenu $w.font.nom FONTNAME \
		{Times-Roman} {Times-Bold} {Helvetica} {Helvetica-Bold} \
		{Courier} {Courier-Bold}
	pack $w.font.sl $w.font.som $w.font.nl $w.font.nom -side left

	frame $w.sep3 -bg black -height 2
	pack $w.sep3 -expand 1 -fill x


	# hole diameter
	frame $w.hd
	pack $w.hd -expand 1 -fill x
	label $w.hd.l -text "Hole Diameter" -width $labwid
	entry $w.hd.e -width 6 -rel sunk -textvar HOLEDIAM
	bind $w.hd.e <Tab> "Tab \$pstablist"
	bind $w.hd.e  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.hd.e  <KeyPress> $def_entry_kp
	pack $w.hd.l $w.hd.e -side left

	frame $w.sep5 -bg black -height 2
	pack $w.sep5 -expand 1 -fill x

	# hole marks
	frame $w.hm
	pack $w.hm -expand 1 -fill x
	label $w.hm.l -text "Hole Marks" -width $labwid
	label $w.hm.xl -text "x" -width 2 -rel flat
	entry $w.hm.xe -width 6 -rel sunk -textvar XHOLE
	bind $w.hm.xe <Tab> "Tab \$pstablist"
	bind $w.hm.xe  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.hm.xe  <KeyPress> $def_entry_kp
	label $w.hm.yl -text "y" -width 2 -rel flat
	entry $w.hm.ye -width 6 -rel sunk -textvar YHOLE
	bind $w.hm.ye <Tab> "Tab \$pstablist"
	bind $w.hm.ye  <Delete> {%W delete [expr [%W index insert] - 1]}
	bind $w.hm.ye  <KeyPress> $def_entry_kp
	button $w.hm.add -text "Add" -command {
		if {([string length $XHOLE])&&([string length $YHOLE])} {
			.pssetup.lbf.lb insert end "$XHOLE $YHOLE"
			lappend HOLES "$XHOLE $YHOLE"
			RedrawDiagram 0
		}
	}
	button $w.hm.rem -text "Rem" -command {
		set cur [.pssetup.lbf.lb curselect]
		if {$cur != ""} {
			set punted "[.pssetup.lbf.lb get $cur]"
			DelHole $punted
			.pssetup.lbf.lb delete $cur
			RedrawDiagram 0
		}
	}
	button $w.hm.chg -text "Mod" -command {
		set cur [.pssetup.lbf.lb curselect]
		if {$cur != ""} {
			set punted "[.pssetup.lbf.lb get $cur]"
			DelHole $punted
			.pssetup.lbf.lb delete $cur
			lappend HOLES "$XHOLE $YHOLE"
			.pssetup.lbf.lb insert $cur "$XHOLE $YHOLE"
			.pssetup.lbf.lb selection set $cur
			RedrawDiagram 0
		}
	}
	pack $w.hm.l $w.hm.xl $w.hm.xe $w.hm.yl \
		$w.hm.ye $w.hm.add $w.hm.rem $w.hm.chg \
		-side left

	# hole listbox
	frame $w.lbf
	pack $w.lbf -expand 1 -fill x
	scrollbar $w.lbf.scroll -rel sunk -command "$w.lbf.lb yview"
	listbox $w.lbf.lb -height 6 -width 20 -rel sunk \
		-yscroll "$w.lbf.scroll set"
	pack $w.lbf.scroll -side right -fill y
	pack $w.lbf.lb -side right
	set default_listbox_binding [bind Listbox <1>]
	#puts "default: $default_listbox_binding"
	eval "bind $w.lbf.lb <1> {$default_listbox_binding}"
	bind $w.lbf.lb <1> {+
		set cur [.pssetup.lbf.lb curselect]
		if {$cur != ""} {
			set hole "[.pssetup.lbf.lb get $cur]"
			set XHOLE [lindex $hole 0]
			set YHOLE [lindex $hole 1]
		}
	}
	
	# enter hole coords into listbox
	foreach hole "$HOLES" {
		set x [lindex $hole 0]
		set y [lindex $hole 1]
		$w.lbf.lb insert end "$x $y"
	}

	# message line
	message $w.msg -fg red -aspect 2000 -rel groove
	pack $w.msg -expand 1 -fill x

	# buttons line
	frame $w.buttons
	pack $w.buttons
	button $w.buttons.redraw -text "Redraw Diagram" -command \
		{RedrawDiagram 0} -state disabled
	button $w.buttons.write -text "Print" -command {PrintDoc}
	button $w.buttons.quit -text "Quit!" -command {set SWvar 0}
	pack $w.buttons.redraw $w.buttons.write $w.buttons.quit \
		-side left -padx 10
	
	set done 0
	while {!$done} {
		tkwait variable SWvar
		if {$SWvar == 0} {set done 1}
	}
	if {$diagram} {
		destroy .diagram
		set diagram 0
		$w.buttons.redraw config -state disabled
	}
	destroy $w
}

proc DelHole {thishole} {
	global HOLES

	set thisx [lindex $thishole 0]
	set thisy [lindex $thishole 1]
	set newlist ""
	foreach hole "$HOLES" {
		set x [lindex $hole 0]
		set y [lindex $hole 1]
		if {($thisx != $x)||($thisy != $y)} {
			lappend newlist "$hole"
		}
	}
	set HOLES "$newlist"
}

set switches(PAPERSIZE)		"-ps"
set switches(PAGEWIDTH)		"-pw"
set switches(PAGEHEIGHT)	"-ph"
set switches(TOPM)			"-tm"
set switches(FONTNAME)		"-fn"
set switches(BOTM)			"-bm"
set switches(LEFTM)			"-lm"
set switches(RIGHTM)		"-rm"
set switches(FONTSIZE)		"-fs"
set switches(HOLEDIAM)		"-hd"
set switches(FILENAME)		"-o"
set switches(ADDRWIDTH)		"-aw"
set switches(SEPARATION)	"-sep"


proc PrintDoc {} {
	global PAPERSIZE PAGEWIDTH PAGEHEIGHT TOPM FONTNAME
	global BOTM LEFTM RIGHTM FONTSIZE HOLEDIAM FILENAME
	global ADDRWIDTH SEPARATION switches
	global HOLES A4WIDTH A4HEIGHT USWIDTH USHEIGHT
	global master_list PSFormatScript

	if {$PAPERSIZE == "A4"} {
		set width $A4WIDTH
		set height $A4HEIGHT
	} else {
		set width $USWIDTH
		set height $USHEIGHT
	}

	foreach var "PAPERSIZE PAGEWIDTH PAGEHEIGHT TOPM \
		BOTM LEFTM RIGHTM FONTSIZE HOLEDIAM ADDRWIDTH SEPARATION" {
		set val [set $var]
		if {$val < 0} {
			SetupMessage "$var can't be negative"
			return;
		}
	}
	if {![string length $FILENAME]} {
		SetupMessage "Filename not specified"
		return;
	}
	if {![CheckPath $FILENAME]} {
		#puts "invalid path"
		SetupMessage "invalid path/no permission"
		return;
	}

	#set psformatargs "-ps $PAPERSIZE -pw $PAGEWIDTH -ph $PAGEHEIGHT \
	#	-tm $TOPM -fn $FONTNAME -bm $BOTM -lm $LEFTM -rm $RIGHTM \
	#	-fs $FONTSIZE -hd $HOLEDIAM -o $FILENAME"

	set psformatargs ""
	foreach var [array names switches] {
		catch {set val [set $var]}
		if {$val != ""} {
			append psformatargs " $switches($var) $val"
		}
	}

	foreach hole "$HOLES" {
		set x [lindex $hole 0]
		set y [lindex $hole 1]
		append psformatargs " -hole $x $y"
	}

	set cmd "$PSFormatScript $psformatargs"
	#puts "cmd=$cmd"

	set file_id [open "|$cmd" "w"]
	foreach ent $master_list {
		################################
		# substitute \n's for carriage
		# returns in 'misc' widget
		################################
		set tmp [lindex $ent 5]
		if {[string length $tmp]} {
			regsub -all "\n" $tmp {\n} tmp
			set ent [lreplace $ent 5 5 $tmp]
		}
		puts $file_id "$ent"
	}
	close $file_id
}

proc SetupMessage {msg} {
	.pssetup.msg config -text "$msg"
	after 2000 ".pssetup.msg config -text {}"
}

proc MakeDiagram {} {
	global diagram dvar
	
	set diagram 1
	.pssetup.buttons.redraw config -state normal
	set w .diagram
	toplevel $w
	canvas $w.c -height 20c -width 15c
	pack $w.c
	button $w.b -text "Dismiss" -command {
		set dvar 1
		set diagram 0
	}
	pack $w.b
	RedrawDiagram 0
	tkwait variable dvar
	set diagram 0
	.pssetup.buttons.redraw config -state disabled
	destroy $w
}

proc RedrawDiagram {check} {
	global PAPERSIZE PAGEWIDTH PAGEHEIGHT TOPM ADDRWIDTH SEPARATION
	global BOTM LEFTM RIGHTM FONTSIZE FONTNAME HOLEDIAM
	global HOLES A4WIDTH A4HEIGHT USWIDTH USHEIGHT

	if {$PAPERSIZE == "A4"} {
		set width $A4WIDTH
		set height $A4HEIGHT
	} else {
		set width $USWIDTH
		set height $USHEIGHT
	}

	if {$check} {
		if {[expr $PAGEWIDTH * 2] > [expr $width - 2]} {
			SetupMessage "2up will be used, page too wide"
		} elseif {[expr $PAGEHEIGHT * 2] > [expr $height - 2]} {
			SetupMessage "2up will be used, page too long"
		}
	}

	#puts "HOLES=\[$HOLES\]"
	set c ".diagram.c"
	if {![winfo exists $c]} {return}
	$c delete all
	set xoff 0.5
	set yoff 0.5
	$c config -height "[expr $yoff + $PAGEHEIGHT + 1.0]c"
	$c config -width "[expr $xoff + $PAGEWIDTH + 1.0]c"
	
	# page outline
	$c create rectangle "${xoff}c" "${yoff}c" "[expr $xoff + $PAGEWIDTH]c" \
		"[expr $yoff + $PAGEHEIGHT]c" -width 2

	# margins
	$c create rectangle "[expr $xoff + $LEFTM]c" \
		"[expr $yoff + $TOPM]c" \
		"[expr $xoff + $PAGEWIDTH - $RIGHTM]c" \
		"[expr $yoff + $PAGEHEIGHT - $BOTM]c" \
		-outline red

	# address + telephone areas
	if {$ADDRWIDTH != ""} {
		if {$SEPARATION == ""} {set SEPARATION 0.3}
		# address rectangle
		$c create rectangle \
			"[expr $xoff + $LEFTM]c" \
			"[expr $yoff + $TOPM]c" \
			"[expr $xoff + $LEFTM + $ADDRWIDTH]c" \
			"[expr $yoff + $PAGEHEIGHT - $BOTM]c" \
			-outline green

		# telephone rectangle
		set telstart [expr $xoff + $LEFTM + $ADDRWIDTH + $SEPARATION]
		set telwidth [expr $PAGEWIDTH - \
			($ADDRWIDTH + $LEFTM + $SEPARATION + $RIGHTM)]
		$c create rectangle "${telstart}c" "[expr $yoff + $TOPM]c" \
			"[expr $telstart + $telwidth]c" \
			"[expr $yoff + $PAGEHEIGHT - $BOTM]c" \
			-outline green
	}

	# font example
	set font [ConstructFontName]
	if {[TestFont $font]} {
		# address example
		set x [expr $xoff + $LEFTM + 0.1]
		set y [expr $yoff + $TOPM]
		#puts "y=$y"
		$c create text "${x}c" "${y}c" -text "Joe Schmo" -font $font -anch nw
		set y [expr $y + $FONTSIZE * 2.54 / 72]
		$c create text "${x}c" "${y}c" -text "666 Nowwhere St." \
			-font $font -anch nw
		set y [expr $y + $FONTSIZE * 2.54 / 72]
		$c create text "${x}c" "${y}c" -text "Lostville, MO 00000" \
			-font $font -anch nw

		# telephone example
		set x [expr $xoff + $LEFTM + $ADDRWIDTH + $SEPARATION]
		set y [expr $yoff + $TOPM]
		$c create text "${x}c" "${y}c" -text "(222) 555-1212" -font $font \
			-anch nw
	} else {
		SetupMessage "failed to find font for font example"
	}

	# holes
	set radius [expr $HOLEDIAM / 2]
	foreach hole "$HOLES" {
		set x [lindex $hole 0]
		set y [lindex $hole 1]
		$c create oval \
			"[expr $xoff + $x - $radius]c" \
			"[expr $yoff + $y - $radius]c" \
			"[expr $xoff + $x + $radius]c" \
			"[expr $yoff + $y + $radius]c" 
			#-fill blue
	}
}

proc ConstructFontName {} {
	global FONTNAME FONTSIZE

	set fontsize ${FONTSIZE}
	if {[expr $FONTSIZE % 2]} {
		#set fontsize [expr $FONTSIZE + 1]
	}
	set fontsize "${fontsize}0"

	if {[regexp {^(.*)-(.*)$} $FONTNAME junk one two]} {
		set family [string tolower $one]
		set weight [string tolower $two]
	} else {
		set family $FONTNAME
		set weight "medium"
	}
	if {$weight == "roman"} {
		set weight "medium"
	}
	return "-*-${family}-${weight}-r-normal--*-${fontsize}-*-*-*-*-*-*"
}

proc GetDefaults {} {
	global defaults_file gd_name gd_value HOLES
	
	if {[catch {set file_id [open $defaults_file "r"]}]} {return}
	while {[gets $file_id line] != -1} {
		if {[regexp {^#} $line]} {continue}
		set tag [lindex $line 0]
		if {[string match "VAR" $tag]} {
			set gd_name [lindex $line 1]
			set gd_value [lindex $line 2]
			uplevel #0 {set $gd_name $gd_value}
		} elseif {[string match "HOLE" $tag]} {
			set x [lindex $line 1]
			set y [lindex $line 2]
			lappend HOLES "$x $y"
		} else {
			puts "unrecognized line in defaults_file: $line"
		}
	}
	#puts "GetDefaults: HOLES=\[$HOLES\]"
	close $file_id
}

proc WriteDefaults {} {
	global defaults_file optvars HOLES

	set fid [open $defaults_file "w"]
	foreach var "$optvars" {
		upvar #0 $var ref
		#set value [set $var]
		puts $fid "VAR $var $ref"
	}
	foreach hole "$HOLES" {
		set x [lindex $hole 0]
		set y [lindex $hole 1]
		puts $fid "HOLE $x $y"
	}
	close $fid
}
